/***********************************************************************
 *
/***********************************************************************
 *
 Copyright  1995 - 1998, 3Com Corporation or its subsidiaries ("3Com").  
 All rights reserved.
   
 This software may be copied and used solely for developing products for 
 the Palm Computing platform and for archival and backup purposes.  Except 
 for the foregoing, no part of this software may be reproduced or transmitted 
 in any form or by any means or used to make any derivative work (such as 
 translation, transformation or adaptation) without express written consent 
 from 3Com.

 3Com reserves the right to revise this software and to make changes in content 
 from time to time without obligation on the part of 3Com to provide notification 
 of such revision or changes.  
 3COM MAKES NO REPRESENTATIONS OR WARRANTIES THAT THE SOFTWARE IS FREE OF ERRORS 
 OR THAT THE SOFTWARE IS SUITABLE FOR YOUR USE.  THE SOFTWARE IS PROVIDED ON AN 
 "AS IS" BASIS.  3COM MAKES NO WARRANTIES, TERMS OR CONDITIONS, EXPRESS OR IMPLIED, 
 EITHER IN FACT OR BY OPERATION OF LAW, STATUTORY OR OTHERWISE, INCLUDING WARRANTIES, 
 TERMS, OR CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND 
 SATISFACTORY QUALITY.

 TO THE FULL EXTENT ALLOWED BY LAW, 3COM ALSO EXCLUDES FOR ITSELF AND ITS SUPPLIERS 
 ANY LIABILITY, WHETHER BASED IN CONTRACT OR TORT (INCLUDING NEGLIGENCE), FOR 
 DIRECT, INCIDENTAL, CONSEQUENTIAL, INDIRECT, SPECIAL, OR PUNITIVE DAMAGES OF 
 ANY KIND, OR FOR LOSS OF REVENUE OR PROFITS, LOSS OF BUSINESS, LOSS OF INFORMATION 
 OR DATA, OR OTHER FINANCIAL LOSS ARISING OUT OF OR IN CONNECTION WITH THIS SOFTWARE, 
 EVEN IF 3COM HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

 3Com, HotSync, Palm Computing, and Graffiti are registered trademarks, and 
 Palm III and Palm OS are trademarks of 3Com Corporation or its subsidiaries.

 IF THIS SOFTWARE IS PROVIDED ON A COMPACT DISK, THE OTHER SOFTWARE AND 
 DOCUMENTATION ON THE COMPACT DISK ARE SUBJECT TO THE LICENSE AGREEMENT 
 ACCOMPANYING THE COMPACT DISK.

 ******************************************************************************
 *
 * PROJECT:  Pilot
 * FILE:     Category.h
 * AUTHOR:	 Art Lamb: March 7, 1995
 *
 * DECLARER: UI
 *
 * DESCRIPTION:
 *	  This file defines category structures and routines.
 *
 ***********************************************************************/
#ifndef __CATEGORY_H__
#define __CATEGORY_H__


typedef struct {
   Word	renamedCategories;
	Char	categoryLabels [dmRecNumCategories] [dmCategoryLength];
	Byte	categoryUniqIDs[dmRecNumCategories];
	Byte	lastUniqID;	// Uniq IDs generated by the device are between
							// 0 - 127.  Those from the PC are 128 - 255.
} AppInfoType;

typedef AppInfoType * AppInfoPtr;


#ifdef __cplusplus
extern "C" {
#endif

extern void CategoryCreateListV10 (const DmOpenRef db, const ListPtr lst, 
	const Word currentCategory, const Boolean showAll)
							SYS_TRAP(sysTrapCategoryCreateListV10);

extern void CategoryCreateList (const DmOpenRef db, const ListPtr listP, 
	const Word currentCategory, const Boolean showAll, 
	const Boolean showUneditables, const Byte numUneditableCategories, 
	const DWord editingStrID, const Boolean resizeList)
							SYS_TRAP(sysTrapCategoryCreateList);


extern void CategoryFreeListV10 (const DmOpenRef db, const ListPtr lst)
							SYS_TRAP(sysTrapCategoryFreeListV10);

extern void CategoryFreeList (const DmOpenRef db, const ListPtr listP, 
	const Boolean showAll, const DWord editingStrID)
							SYS_TRAP(sysTrapCategoryFreeList);

extern Word CategoryFind (const DmOpenRef db, const Char * const name)
							SYS_TRAP(sysTrapCategoryFind);

extern void CategoryGetName (const DmOpenRef db, const Word index, Char * const name)
							SYS_TRAP(sysTrapCategoryGetName);

extern Boolean CategoryEditV10 (const DmOpenRef db, const WordPtr category)
							SYS_TRAP(sysTrapCategoryEditV10);

extern Boolean CategoryEditV20 (const DmOpenRef db, const WordPtr category, 
	const DWord titleStrID)
							SYS_TRAP(sysTrapCategoryEditV20);

extern Boolean CategoryEdit (const DmOpenRef db, const WordPtr category, 
	const DWord titleStrID, const Byte numUneditableCategories)
							SYS_TRAP(sysTrapCategoryEdit);

extern Boolean CategorySelectV10 (const DmOpenRef db, const FormPtr frm, 
	const Word ctlID, const Word lstID,	const Boolean title, const WordPtr categoryP, 
	CharPtr categoryName)
							SYS_TRAP(sysTrapCategorySelectV10);

extern Boolean CategorySelect (const DmOpenRef db, const FormPtr frm, 
	const Word ctlID, const Word lstID,	const Boolean title, const WordPtr categoryP, 
	CharPtr categoryName, const Byte numUneditableCategories, DWord editingStrID)
							SYS_TRAP(sysTrapCategorySelect);

extern Word CategoryGetNext (const DmOpenRef db, Word index)
							SYS_TRAP(sysTrapCategoryGetNext);

extern void CategorySetTriggerLabel (const ControlPtr ctl, CharPtr name)
							SYS_TRAP(sysTrapCategorySetTriggerLabel);

extern void CategoryTruncateName (CharPtr name, const Word maxWidth)
							SYS_TRAP(sysTrapCategoryTruncateName);

extern void CategoryInitialize (AppInfoPtr appInfoP, const Word localizedAppInfoStrID)
							SYS_TRAP(sysTrapCategoryInitialize);


extern void CategorySetName (const DmOpenRef db, Word index, const CharPtr nameP)
							SYS_TRAP(sysTrapCategorySetName);

#ifdef __cplusplus 
}
#endif

#endif // __CATEGORY_H__